	#include "stdafx.h"
	#include "windows.h"
	#include <stdio.h>
	#include "nativeAPI.h"

	void ListProcessNThread();

	int main(int argc, char* argv[])
	{
		ListProcessNThread();
		return 0;
	}


	void ListProcessNThread()
	{
		ULONG	dwAllocedSize, dwNeeded;
		PSYSTEM_PROCESSES pProcesses;
		NTSTATUS Status;
		int nThreadCount = 0;
		
		//1. Get Buffer of information data
		dwAllocedSize = 0x1000;
		while(TRUE)
		{
			pProcesses = (PSYSTEM_PROCESSES)VirtualAlloc(NULL, dwAllocedSize, 
														MEM_COMMIT, PAGE_READWRITE);
			
	Status = ZwQuerySystemInformation(SystemProcessesAndThreadsInformation,
											pProcesses, dwAllocedSize, &dwNeeded);
			
			if(Status == STATUS_INFO_LENGTH_MISMATCH)
			{
				VirtualFree(pProcesses, dwAllocedSize, MEM_DECOMMIT);
				if(dwNeeded > dwAllocedSize)
					dwAllocedSize = dwNeeded;
				else
					dwAllocedSize += 0x500;
			}
			else if (NT_SUCCESS(Status))
			{
				break;
			}
			else
			{
				break;
			}
		}

		while(pProcesses->NextEntryDelta != 0)
		{
			pProcesses = (PSYSTEM_PROCESSES)((char *)pProcesses + 
											pProcesses->NextEntryDelta);
			//Print Process Information
			printf("PID:%d - %.*ws\n", 
						pProcesses->ProcessId, 
						pProcesses->ProcessName.Length / 2,
						pProcesses->ProcessName.Buffer);
			
			//Print Thread
			for(ULONG nIndex = 0 ; nIndex < pProcesses->ThreadCount ; nIndex ++)
			{
				printf("    [%d], StartAddress : 0x%08x\n", 
						pProcesses->Threads[nIndex].ClientId.UniqueThread, 
						pProcesses->Threads[nIndex].StartAddress);

			}
		}
	}

