#ifndef _UNDOCNTAPI_H
#define _UNDOCNTAPI_H

// /////////////////////////////////////////////////////////////////////////////////////////////////////
// Undocument
// /////////////////////////////////////////////////////////////////////////////////////////////////////
__declspec(dllimport) KeAttachProcess(void *);
__declspec(dllimport) KeDetachProcess();


NTSYSAPI 
NTSTATUS 
NTAPI 
KeI386AllocateGdtSelectors(
	PUSHORT pSelectorArray, 
	ULONG NumberOfSelectors
);

NTSYSAPI 
NTSTATUS 
NTAPI 
KeI386ReleaseGdtSelectors(
	PUSHORT pSelectorArray, 
	ULONG NumberOfSelectors
);

NTSYSAPI 
NTSTATUS 
NTAPI 
KeI386SetGdtSelector(
	ULONG Selector, 
	PVOID pDescriptor
);

#pragma pack(1)

typedef struct _SERVICE_DESCRIPTOR_ENTRY
{
	unsigned int *ServiceTableBase;
	unsigned int *ServiceCounterTableBase; 
	unsigned int NumberOfServices;
	unsigned char *ParamTableBase;
} SERVICE_DESCRIPTOR_ENTRY, *PSERVICE_DESCRIPTOR_ENTRY;

__declspec(dllimport)  SERVICE_DESCRIPTOR_ENTRY KeServiceDescriptorTable;



#endif
